天天看点

Codeforces Round #369 (Div. 2) 711C Coloring Tree (DP)

C. Coloring Trees time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can’t color the trees that are already colored.

Input

The first line contains three integers, n, m and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, …, cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color j. pi, j’s are specified even for the initially colored trees, but such trees still can’t be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples Input

3 2 2
0 0 0
1 2
3 4
5 6
      

Output

10      

Input

3 2 2
2 1 2
1 3
2 4
3 5
      

Output

-1      

Input

3 2 2
2 0 0
1 3
2 4
3 5
      

Output

5      

Input

3 2 3
2 1 2
1 3
2 4
3 5
      

Output

Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is  - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

题解:

这道题肯定是dp,我们很容易就可以得到状态转移方程,我们把dp[i][j][k]表示第i颗数涂上j颜色,此时为k组的最少的涂料。

然后我们O(n*k*m^2),转移就可以了。

初始化的时候dp[0][i][0] ( 0<=i<=100)是可以等于0的,然后我们就可以转移,注意我这里转移的时候颜色从0开始的。

#include<bits/stdc++.h>
using namespace std;

const __int64 inf=;
int n,m,k;
int cost[][];
int color[];

__int64 dp[][][];

int main() {
#ifdef tangge
    freopen("C.in","r",stdin);
#endif // tangge
    while(~scanf("%d%d%d",&n,&m,&k)) {
        for(int i=; i<=n; ++i) {
            scanf("%d",&color[i]);
        }
        for(int i=; i<=n; ++i) {
            for(int j=; j<=m; ++j) {
                scanf("%d",&cost[i][j]);
            }
        }
        for(int i=; i<; ++i) {
            for(int j=; j<; ++j) {
                for(int z=; z<; ++z) {
                    dp[i][j][z]=inf;
                }
            }
        }
        for(int i=; i<; ++i) {
            dp[][i][]=;
        }
        for(int i=; i<=n; ++i) {
            if(color[i]) {
                for(int j=; j<=k; ++j) {
                    for(int l=; l<=m; ++l) {
                        if(l^color[i]) {
                            dp[i][color[i]][j]=min(dp[i][color[i]][j],dp[i-][l][j-]);
                        } else {
                            dp[i][color[i]][j]=min(dp[i][color[i]][j],dp[i-][color[i]][j]);
                        }
                    }
                }
            } else {
                for(int j=; j<=k; ++j) {
                    for(int l=; l<=m; ++l) {
                        for(int h=; h<=m; ++h) {
                            if(l^h) {
                                dp[i][h][j]=min(dp[i][h][j],dp[i-][l][j-]+cost[i][h]);
                            } else {
                                dp[i][h][j]=min(dp[i][h][j],dp[i-][h][j]+cost[i][h]);
                            }
                        }
                    }
                }
            }
        }
        __int64 ans=inf;
        for(int i=; i<=m; ++i) {
            ans=min(ans,dp[n][i][k]);
        }
        cout<<(ans==inf?-:ans)<<endl;
    }
    return ;
}